#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<sstream>
#include<time.h>
using namespace std;
#define s 3
#define n 9
void output(int arr[n][n]);
void USER_FILL(int (&arr)[n][n]);
void pauseAndSave(int (&arr)[n][n],int (&grid)[n][n]);
int str2dig(string str);
bool USER[n][n];
void user_input(int (&arr)[n][n])
{
    string row;
    int m;
    cout<<endl<<"Enter the grid row-by-row"<<endl<<endl;
    cin.ignore();
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<n;j++)
            arr[i][j]=0;
    }
    for(int i=0;i<n;i++)
    {
        getline(cin,row,'\n');
        m=row.length();
        for(int j=0;j<m;j++)
        {
            if(row[j]>='1' && row[j]<='9')
                arr[i][j]=row[j]-48;
            else
                arr[i][j]=0;
        }
    }
	cout<<endl<<endl<<"The given input is:-"<<endl<<endl;
	output(arr);
}

int solver(int (&arr)[n][n])
{
    bool InRows[n][n];
    bool InCols[n][n];
    bool InBox[s][s][n];
    bool cond=true;
    int i,j,k,x;
    char c;
    for(i=0;i<s;i++)
    {
        for(j=0;j<s;j++)
	    {
	        for(k=0;k<n;k++)
            {
                InBox[i][j][k]=false;
            }
	    }
    }
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            InRows[i][j]=false;
            InCols[i][j]=false;
            USER[i][j]=false;
        }
    }
    for(i=0;i<n && cond;i++)
    {
        for(j=0;j<n;j++)
        {
            if(arr[i][j]>0 )
            {
                x=arr[i][j]-1;
                if(InRows[i][x]==false && InCols[x][j]==false && InBox[(int)floor(i/s)][(int)floor(j/s)][x]==false)
                {
                    USER[i][j]=true ;
                    InRows[i][x]=true;
                    InCols[x][j]=true;
                    InBox[(int)floor(i/s)][(int)floor(j/s)][x]=true;
                }
                else
                {
                    cond=false;
                    break;
                }
            }
        }
    }
    i=0;
    j=0;
    while(i<n && j<n && i>=0 && cond)
    {
        if(USER[i][j]==true)
        {
            j++;
            if(j==n)
            {
                j=0 ;
                i++;
            }
            continue;
        }
        x=arr[i][j];
        if(x>0)
        {
            InRows[i][x-1]=false;
            InCols[x-1][j]=false;
            InBox[(int)floor(i/s)][(int)floor(j/s)][x-1]=false;
        }
        x++;
        while(x<=n)
        {
            if(InRows[i][x-1]==false && InCols[x-1][j]==false && InBox[(int)floor(i/s)][(int)floor(j/s)][x-1]==false)
                break;
            x++;
        }

        if(x>9)
        {
            arr[i][j]=0;
            while(1)
            {
                j--;
                if(j<0)
                {
                    j=n-1;
                    i--;
                }
                if(i<0 || USER[i][j]==false)
                {
                    break;
                }
            }
        }
        else
        {
            arr[i][j]=x;
            InRows[i][x-1]=true;
            InCols[x-1][j]=true;
            InBox[(int)floor(i/s)][(int)floor(j/s)][x-1]=true;
            j++;
            if(j==n)
            {
                j=0;
                i++;
            }
        }
    }
    if(cond==false || i<0)
	{
	    cout<<endl<<"Incorrect Grid!!!"<<endl<<endl;
	    return -1;
	}
    return 0;
}

void USER_FILL(int (&arr)[n][n])
{
    srand(time(NULL));
    int ch,w=(rand()%20)+1;
    char fil[20]="";
    int row,col,item,end_flag=0,flag=0;
    string strinp;
    int choice;
    const char *cstr;
    cout<<"\nEasy--> 1\nMedium-->2\nHard-->3\nResume a paused game-->4\n\nChoice:";
    cin.ignore();
    cin>>strinp;
    ch=str2dig(strinp);
    switch(ch)
    {
        case 1:
            strcpy(fil,"Easy/");
            break;
        case 2:
            strcpy(fil,"Medium/");
            break;
        case 3:
            strcpy(fil,"Hard/");
            break;
        case 4:
            strcpy(fil,"Paused/");
            cout<<"\nEnter name of saved puzzle:";
            cin.ignore();
            getline(cin,strinp,'\n');
            cstr = strinp.c_str();
            strcat(fil,cstr);
            break;
        default:
            cout<<"\nWrong Input!\n\n";
            strcpy(fil," ");
    }
    if(ch!=4)
    {
        stringstream ss;
        ss<<w;
        string str=ss.str();
        cstr = str.c_str();
        strcat(fil,cstr);
    }
    strcat(fil,".txt");
    cout<<endl<<endl;
    FILE *fp; char r[(n*n)*2+1];
    fp=fopen(const_cast <char *>(fil) , "r");
    if(fp==NULL)
    {
        if(ch==4)
            cout<<"\nno such saved game found!!!\n\n";
        else
            cout<<"\nCould Not Open File!\n\n";
    }
    else
    {
        int x,k=0,i,j;
        int grid[n][n];
        int savegrid[n][n];
        if(ch==4)
            fgets(r,(n*n*2)+1,fp);
        else
            fgets(r,(n*n)+1,fp);
        for(i=0;i<n;i++)
        {
            for(j=0;j<n;j++)
            {
                grid[i][j]=r[k++]-48;
                savegrid[i][j]=grid[i][j];
            }
        }
        if(ch==4)
        {
            for(i=0;i<n;i++)
            {
                for(j=0;j<n;j++)
                {
                    arr[i][j]=r[k++]-48;
                }
            }
        }
        else
        {
            for(i=0;i<n;i++)
            {
                for(j=0;j<n;j++)
                {
                    arr[i][j]=grid[i][j];
                }
            }
        }
        for(i=0;i<n;i++)
        {
            for(j=0;j<n;j++)
            {
                if(grid[i][j]>0 )
                {
                    USER[i][j]=true ;
                }
            }
        }
        fclose(fp);
        output(arr);
        solver(grid);
        while(end_flag!=1)
        {
            cout<<"\nEnter Box you want to put number in: (or press 'x' in place of 'row' to pause and save the current game)\n";
            cout<<"          (alternatively, press 's' in place of 'row' if you are bored and want the solution)\n";
            row=0;
            col=0;
            while(row<1 || row>9)
            {
                cout<<"Row:";
                cin>>strinp;
                row=str2dig(strinp);
                if(row==40 || row== 72)/*checking if input is x-48 or X-48*/
                {
                    pauseAndSave(arr,savegrid);
                    end_flag=1;
                    break;
                }
                else if(row==35 || row==67)/*checking if input is s-48 or S-48*/
                {
                        cout<<"\nSolution:\n\n";
                        output(grid);
                        end_flag=1;
                        break;
                }
                else if(row<1 ||row>9)
                {
                    cout<<"\nRow value out of bounds\nEnter Again\n\n";
                }
            }
            if(end_flag==1)
                break;
            while(col<1 || col>9)
            {
                cout<<"Column:";
                cin>>strinp;
                col=str2dig(strinp);
                if(col<1 ||col>9)
                {
                    cout<<"\nColumn value out of bounds\nEnter Again\n\n";
                }
            }
            if(USER[row-1][col-1]==false)
            {
                while(1)
                {
                    cout<<"\nEnter number to be put:";
                    cin>>strinp;
                    item=str2dig(strinp);
                    if(item>=0 && item<=9)
                        break;
                    cout<<"\nWrong Input!Enter numbers from 1 to 9(0 to clear)\n\n";
                }
                arr[row-1][col-1]=item;
                output(arr);
            }
            else
            {
                cout<<"\nThis position is not empty\n\n";
            }
            flag=0;
            for(int l=0;l<n && flag==0;l++)
                for(int m=0;m<n && flag==0;m++)
                    if(arr[l][m]!=grid[l][m])
                         flag=1;
            if(flag==0)
            {
                cout<<"\nCorrect Solution! \n\n";
                 end_flag=1;
            }
        }
    }
}
void output(int arr[n][n])
{
    int i,j;
    cout<<endl<<"              cols"<<endl;
    cout<<"       1 2 3   4 5 6   7 8 9"<<endl;
    cout<<"       | | |   | | |   | | |"<<endl<<"rows"<<endl;
    for(i=0;i<n;i++)
    {
        if(i==3 || i==6)
		cout<<"      ---------------------"<<endl;
        cout<<" "<<(i+1)<<"--   ";
        for(j=0;j<n;j++)
        {
            if(arr[i][j]!=0)
            {
                if(USER[i][j]==true)
                	cout<<arr[i][j]<<"`";
                else
                    cout<<arr[i][j]<<" ";
            }
            else
                cout<<"  ";
            if((j+1)%3==0 && j!=8)
                cout<<"| ";
        }
        cout<<endl;
    }
    cout<<endl;
}

int str2dig(string str)
{
	if(str.length()==1)
		return str[0]-48;
	return -1;
}
void pauseAndSave(int (&arr)[n][n],int (&savegrid)[n][n])
{
	string strinp;
	int i,j;
	char strout[n*n*2];
	char fil[20]="Paused/";
	cout<<"\nenter your name:";
	cin.ignore();
	getline(cin,strinp,'\n');
	const char* cstr = strinp.c_str();
        strcat(fil,cstr);
	strcat(fil,".txt");
	FILE *fp=fopen(const_cast <char *>(fil) , "w");
	int k=0;
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			strout[k++]=savegrid[i][j]+48;
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			strout[k++]=arr[i][j]+48;
	fwrite(strout,sizeof(char),n*n*2,fp);
	fclose(fp);
	cout<<"\nsave successful!!!\n\n";
}
int main()
{
    string c;
    int grid[n][n];
    int num;
    while(1)
    {
        cout<<"Solver-->1\nGenerator-->2\nExit-->3\nChoice:";
        cin>>c;
        if(c.compare("1")==0)
        {
                user_input(grid);
                cout<<endl<<"solving..."<<endl<<endl;
                num=solver(grid);
                if(num!=-1)
                {
                    cout<<endl<<"Solution:"<<endl<<endl;
                    output(grid);
                }
        }
        else if(c.compare("2")==0)
        {
                USER_FILL(grid);
        }
         else if(c.compare("3")==0)
         {
                cout<<"\nThank You for Using Sudoku Solver\n\n";
                break;
        }
    }
    return 0;
}
