#include<iostream>
#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<math.h>
#include<simplecpp.h>
using namespace std;
#define s 3
#define n 9
int grid[n][n];
void output(int arr[n][n]);
void output(char arr[n][n]);
void output(bool arr[n][n]);
int box()
{
    initCanvas();
    Turtle t1,t2,t3;
    t1.left(100);
    t2.right(100);
    t3.forward(100);
    t1.left(360.0/8);
    t1.forward(100);
    t2.right(360.0/8);
    t2.forward(100);
    return 0;
}
void user_input()
{
    char row[n+2];
    int m;
    cout<<endl<<"Enter the grid row-by-row"<<endl<<endl;
    for(int i=0;i<n;i++)
    {
        fgets(row,n+2,stdin);
        m=strlen(row)-1;
        for(int j=0;j<m;j++)
        {
            if(row[j]>='1' && row[j]<='9')
                grid[i][j]=row[j]-48;
	    else
		grid[i][j]=0;
        }
    }
	cout<<endl<<endl<<"The given input is:-"<<endl<<endl;
	output(grid);
}

int solver()
{
    bool USER[n][n];
    bool InRows[n][n];
    bool InCols[n][n];
    bool InBox[s][s][n];
    bool cond=true;
    int i,j,k,x;
    char c;
    cout<<endl<<"solving..."<<endl<<endl;
    for(i=0;i<s;i++)
    {
        for(j=0;j<s;j++)
	    {
	        for(k=0;k<n;k++)
            {
                InBox[i][j][k]=false;
            }
	    }
    }
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            InRows[i][j]=false;
            InCols[i][j]=false;
            USER[i][j]=false;
        }
    }
    for(i=0;i<n && cond;i++)
    {
        for(j=0;j<n;j++)
        {
            if(grid[i][j]>0 )
            {
                x=grid[i][j]-1;
                if(InRows[i][x]==false && InCols[x][j]==false && InBox[(int)floor(i/s)][(int)floor(j/s)][x]==false)
                {
                    USER[i][j]=true ;
                    InRows[i][x]=true;
                    InCols[x][j]=true;
                    InBox[(int)floor(i/s)][(int)floor(j/s)][x]=true;
                }
                else
                {
                    cond=false;
                    break;
                }
            }
        }
    }
    i=0;
    j=0;
    while(i<n && j<n && i>=0 && cond)
    {
        if(USER[i][j]==true)
        {
            j++;
            if(j==n)
            {
                j=0 ;
                i++;
            }
            continue;
        }
        x=grid[i][j];
        if(x>0)
        {
            InRows[i][x-1]=false;
            InCols[x-1][j]=false;
            InBox[(int)floor(i/s)][(int)floor(j/s)][x-1]=false;
        }
        x++;
        while(x<=n)
        {
            if(InRows[i][x-1]==false && InCols[x-1][j]==false && InBox[(int)floor(i/s)][(int)floor(j/s)][x-1]==false)
                break;
            x++;
        }

        if(x>9)
        {
            grid[i][j]=0;
            while(1)
            {
                j--;
                if(j<0)
                {
                    j=n-1;
                    i--;
                }
                if(i<0 || USER[i][j]==false)
                {
                    break;
                }
            }
        }
        else
        {
            grid[i][j]=x;
            InRows[i][x-1]=true;
            InCols[x-1][j]=true;
            InBox[(int)floor(i/s)][(int)floor(j/s)][x-1]=true;
            j++;
            if(j==n)
            {
                j=0;
                i++;
            }
        }
    }
    if(cond==false || i<0)
	cout<<endl<<"incorrect grid!!!"<<endl<<endl;
    else
    {
   	cout<<endl<<"the solution is:-"<<endl<<endl;
        output(grid);
    }
    return 0;
}
void output(int arr[n][n])
{
    int i,j;
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            cout<<arr[i][j]<<" ";
            if(j%3==0)
                cout<<"|";
        }
        cout<<endl;
    }
    cout<<endl;
    if(i%3==0)
        for(j=0;j<n;j++)
            cout<<"_";
}
void output(char arr[n][n])
{
    int i,j;
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            cout<<arr[i][j]<<" ";
            if(j%3==0)
                cout<<"|";
        }
        cout<<endl;
    }
    cout<<endl;
    if(i%3==0)
        for(j=0;j<n;j++)
            cout<<"_";
}
void output(bool arr[n][n])
{
    int i,j;
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            cout<<arr[i][j]<<" ";
            if(j%3==0)
                cout<<"|";
        }
        cout<<endl;
    }
    cout<<endl;
    if(i%3==0)
        for(j=0;j<n;j++)
            cout<<"_";
}
int main()
{
    int c;
    cout<<"Solver-->1\nGenerator-->2\nChoice:";
    cin>>c;
    switch(c)
    {
        case 1:
            user_input();
            solver();
            break;
        case 2:
            int ch,w=rand()%20; char s[20];
            cout<<"Easy--> 1\nMedium-->2\nHard-->3\nChoice:";
            cin>>ch;
            switch(ch)
            {
                case 1:
                    strcpy(s,"Easy/");
                    break;
                case 2:
                    strcpy(s,"Medium");
                    break;
                case 3:
                    strcpy(s,"Hard/");
                    break;
                default:
                    cout<<"Wrong Input!";
                    s=0;
                    break;
            }
            s+=w;
            s+=".txt";
            FILE *fp; char r[(n*n)+1];
            fp=fopen(s,'r');
            if(fp==NULL)
            {
                cout<<"Could Not Open File!\n";
                return -1;
            }
            fgets(r,n*n,fp);
            for(int i=0;i<n;i++)
            {
                for(int j=0;j<n;j++)
                {
                    grid[i][j]=r[k]-48;
                }
            }
            while(1)
            {
                cout<<"Enter Box you want to put number in:\nRow:";
                cin>>row;
                cout<<"Column:";
                cin>>col;
            }
    }
//	int c=box();
    return 0;
}
